'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _pick = require('lodash/pick');

var _pick2 = _interopRequireDefault(_pick);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CacheRenderer = function (_React$Component) {
    _inherits(CacheRenderer, _React$Component);

    function CacheRenderer() {
        _classCallCheck(this, CacheRenderer);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(CacheRenderer).apply(this, arguments));
    }

    _createClass(CacheRenderer, [{
        key: 'render',
        value: function render() {
            var items = this.props.items;

            return _react2.default.createElement(
                'div',
                null,
                items.map(function (item) {
                    return _react2.default.createElement(CachePage, _extends({ key: item.id }, (0, _pick2.default)(item, 'args', 'page', 'isActive')));
                })
            );
        }
    }]);

    return CacheRenderer;
}(_react2.default.Component);

CacheRenderer.propTypes = {
    // array of {id, args, page(args), isActive}
    items: _react2.default.PropTypes.arrayOf(_react2.default.PropTypes.object).isRequired
};
CacheRenderer.defaultProps = {
    items: []
};

var CachePage = function (_React$Component2) {
    _inherits(CachePage, _React$Component2);

    function CachePage() {
        _classCallCheck(this, CachePage);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(CachePage).apply(this, arguments));
    }

    _createClass(CachePage, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(oldProps) {
            return !(oldProps.args === this.props.args && oldProps.page === this.props.page && oldProps.isActive === this.props.isActive);
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props;
            var args = _props.args;
            var page = _props.page;
            var isActive = _props.isActive;


            return _react2.default.createElement(
                'div',
                { style: { display: isActive ? 'block' : 'none' } },
                page(args)
            );
        }
    }]);

    return CachePage;
}(_react2.default.Component);

CachePage.propTypes = {
    args: _react2.default.PropTypes.any,

    // page builder, func(args)
    page: _react2.default.PropTypes.func.isRequired,

    isActive: _react2.default.PropTypes.bool
};
exports.default = CacheRenderer;